<?php
/**
 * MyBBPlus 2.0
 * Copyright 2014 MyBBPlus Group, All Rights Reserved
 *
 * Website: http://mybbplus.com
 * License: http://mybbplus.com/about/license
 *
 */

function uncompress($srcName, $dstName) {
    $sfp = gzopen($srcName, "rb");
    $fp = fopen($dstName, "w");

    while (!gzeof($sfp)) {
        $string = gzread($sfp, 4096);
        fwrite($fp, $string, strlen($string));
    }
    gzclose($sfp);
    fclose($fp);
}

function task_geotablerefresh($task)
{
	global $mybb, $settings, $db, $config, $lang, $plugins;
	static $contents;

	@set_time_limit(0);

	if($mybb->settings['mybbplus_geoipdatabasepath']){
		$test = substr($mybb->settings['mybbplus_geoipdatabasepath'],0,1);
		if($test == '/'){
			$file = $mybb->settings['mybbplus_geoipdatabasepath'];
		}else{
			$file = MYBB_ROOT.$mybb->settings['mybbplus_geoipdatabasepath'];
		}
	}else{
		add_task_log($task, $lang->task_geotablerefresh_nopath);
		return;
	}
	// Check if folder is writable, before allowing submission
	if(!is_writable(pathinfo($file, PATHINFO_DIRNAME)))
	{
		add_task_log($task, $lang->task_geotablerefresh_cannot_write);
		return;
	}
	else
	{
		$filename = pathinfo($file, PATHINFO_BASENAME);
		$url = 'http://geolite.maxmind.com/download/geoip/database/'.$filename.'.gz';

		if(function_exists('file_put_contents')){
			file_put_contents($file.'.tmp', fopen($url, 'r'));
			if(file_exists($file.'.old')){
			  unlink($file.'.old');
			}
			if(file_exists($file)){
			  rename($file, $file.'.old');
			}
                     uncompress($file.'.tmp', $file);
			unlink($file.'.tmp');
/*
  ob_start();
  readgzfile($file);
  $d=ob_get_clean();
  return $d;
*/
		}else{
    $out = fopen($file.'.tmp', 'wb'); 
    if ($out == FALSE){ 
	add_task_log($task, $lang->task_geotablerefresh_cannot_write);
       return; 
    } 

    $ch = curl_init(); 

    curl_setopt($ch, CURLOPT_FILE, $out); 
    curl_setopt($ch, CURLOPT_HEADER, 0); 
    curl_setopt($ch, CURLOPT_URL, $url); 
    curl_setopt($ch, CURLOPT_ENCODING, 'gzip,deflate'); 
    curl_exec($ch); 
    curl_close($ch); 
		}
/*
     $ch=curl_init($url);
     curl_setopt($ch, CURLOPT_ENCODING. 'gzip');
     curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
     $content=curl_exec($ch);
     curl_close($ch);
     return $content;



*/
/*
		if(function_exists('gzopen'))
		{
			gzwrite($fp, $contents);
			gzclose($fp);
			rename($file.'.incomplete.sql.gz', $file.'.sql.gz');
		}
		else
		{
			fwrite($fp, $contents);
			fclose($fp);
			rename($file.'.incomplete.sql', $file.'.sql');
		}
*/
		add_task_log($task, $lang->task_geotablerefresh_done);
	}
}

